<?php
// $Id$

class Client {
	var $store;

	function __construct() {
		$this->store = new playoutStorage();
	}

    public function actions() {
        switch(globalize('action')) {
            case 'delete':
				$this->delete(globalize('id'));
				break;
            case 'add':
				$this->add(globalize('clientName'),
							globalize('clientDefaults'));
				break;
            case 'save':
				$this->save(globalize('clientID'),
							globalize('clientName'),
							globalize('clientDefaults'));
				break;
            case 'create':
				$this->create(globalize('clientClass'));
				break;
            case "remove":
				$this->remove(globalize('id'));
				break;
            case "cancel":
				$this->cancel(globalize('id'));
				break;
        }
    }

    public function button_delete($doc, $id = '') {
        $item = globalize('item', get_class($this));

		$spanbutton = $doc->createElement('span');
		$spanbutton->setAttribute('class', 'link_button');
		$spanbutton->appendChild($a = module::link_to_script_dom_unappended($doc,'Delete','',array('item'=>$item,'action'=>'remove','id'=>$id),'Delete','link_button'));
		$a->appendChild($span = $doc->createElement('span'));
		$span->setAttribute('class', 'link_delete');
		$span->appendChild($label = $doc->createTextNode('Delete'));

        return($spanbutton);
	}

    public function button_edit($doc, $id = '') {
        $item = globalize('item', get_class($this));

		$spanbutton = $doc->createElement('span');
		$spanbutton->setAttribute('class', 'link_button');
		$spanbutton->appendChild($a = module::link_to_script_dom_unappended($doc,'Edit','',array('item'=>$item,'action'=>'edit','id'=>$id),'Edit','link_button'));
		$a->appendChild($span = $doc->createElement('span'));
		$span->setAttribute('class', 'link_edit');
		$span->appendChild($label = $doc->createTextNode('Edit'));

        return($spanbutton);
	}

    public function button_import($doc, $id = '') {
        $item = globalize('item', get_class($this));

		$spanbutton = $doc->createElement('span');
		$spanbutton->setAttribute('class', 'link_button');
		$spanbutton->appendChild($a = module::link_to_script_dom_unappended($doc,'Import Client Type','',array('item'=>$item,'action'=>'import'),'Import Client Type','link_button'));
		$a->appendChild($span = $doc->createElement('span'));
		$span->setAttribute('class', 'link_add');
		$span->appendChild($label = $doc->createTextNode('Import Client Type'));

        return($spanbutton);
	}

    public function form($doc, $id = '') {

		$container = $doc->createElement('div');
		$container->setAttribute('class','module');

		if ($id == '')
            $headerText = 'Add Client Type';
        else
            $headerText = 'Edit Client Type';

		$header = $doc->createElement('h1');
		$header->appendChild($doc->createTextNode($headerText));
		$container->appendChild($header);

		/* This input is to end execution of the module index file.
			Because we are forwarding to another page each time we add or save,
			we need to make sure the page doesn't get generated twice */
		$terminate = $doc->createElement('input');
		$terminate->setAttribute('type','hidden');
		$terminate->setAttribute('name','terminate');
		$terminate->setAttribute('value','true');
		$container->appendChild($terminate);

        $clientIDinput = $doc->createElement('input');
        $clientIDinput->setAttribute('type', 'hidden');
        $clientIDinput->setAttribute('name', 'clientID');
        $clientIDinput->setAttribute('value', $id);
        $container->appendChild($clientIDinput);

		// Specify the parameter prefix, display text, and the order of rows.
		$prefix = 'client';
		$display = array(
			'clientID' => '',
			'name' => 'Client Type Name *',
			'defaults' => 'Default Parameters'
		);

        if ($id != '') {
			$query = <<<EOQ
				SELECT {$this->store->playout_client_id} AS clientID,
					{$this->store->playout_client_name} AS name,
					{$this->store->playout_client_defaults} AS defaults
				FROM {$this->store->table_playout_client}
				WHERE {$this->store->playout_client_id} = '$id'
EOQ;

			// Turn result query into a matrix.
			$matrix = sysdb::query2matrix($query,true);

			// Turn result matrix into vectors for processing.
			$keys = $matrix[0];
			$values = $matrix[1];

			$container->appendChild($deletebutton = $this->button_delete($doc, $id));
		} else {
			// Create blank arrays so that table will build.
			$keys = array_keys($display);
			$values = array();
			for($j = 0; $j < sizeof($keys); $j++) {
				$values[] = '';
			}
		}

        $table = $doc->createElement('table');
        $table->setAttribute('class', 'view');

		// Assemble table.
		foreach ($display as $key => $display_text) {
			$i = array_search($key, $keys);

			// Specify peculiarities of returned rows.
			if ($key == 'clientID') {
				$clientID = $values[$i];
				$table->appendChild($client = $doc->createElement('input'));
				$client->setAttribute('type', 'hidden');
				$client->setAttribute('name', $prefix.ucfirst($key));
				$client->setAttribute('value', $values[$i]);
			} else if ($key == 'defaults') {
				$table->appendChild($tr = $doc->createElement('tr'));
				$tr->appendChild($labeltd = $doc->createElement('th'));
				$tr->appendChild($inputtd = $doc->createElement('td'));
				$labeltd->appendChild($label = $doc->createTextNode($display_text));
				$inputtd->appendChild($textarea = $doc->createElement('textarea'));
				$textarea->setAttribute('cols', 50);
				$textarea->setAttribute('rows', 8);
				$textarea->setAttribute('name', $prefix.ucfirst($key));
				$textarea->appendChild($text = $doc->createTextNode($values[$i]));
			} else {
				$table->appendChild($tr = $doc->createElement('tr'));
				$tr->appendChild($labeltd = $doc->createElement('th'));
				$tr->appendChild($inputtd = $doc->createElement('td'));
				$labeltd->appendChild($label = $doc->createTextNode($display_text));
				$inputtd->appendChild($input = $doc->createElement('input'));
				$input->setAttribute('type', 'text');
				$input->setAttribute('name', $prefix.ucfirst($key));
				$input->setAttribute('value', $values[$i]);
			}
		}

        $savetr = $doc->createElement('tr');
        $savetd = $doc->createElement('td');
        $save = $doc->createElement('input');
        $save->setAttribute('type','submit');
        $save->setAttribute('name','action');
        if ($id == '')
            $save->setAttribute('value','add');
        else
            $save->setAttribute('value','save');
        $savetd->appendChild($save);
        $savetr->appendChild($savetd);
        $table->appendChild($savetr);

		$container->appendChild($table);

        return($container);
    }

    public function view($doc, $id = '') {

		$container = $doc->createElement('div');
		$container->setAttribute('class','module');
		$container->appendChild($header = $doc->createElement('h1'));
		$header->appendChild($doc->createTextNode('View Client Type'));

		$container->appendChild($editbutton = $this->button_edit($doc, $id));

        $table = $doc->createElement('table');
        $table->setAttribute('class', 'view');

		$query = <<<EOQ
			SELECT {$this->store->playout_client_id} AS clientID,
				{$this->store->playout_client_name} AS name,
				{$this->store->playout_client_defaults} AS defaults
			FROM {$this->store->table_playout_client}
			WHERE {$this->store->playout_client_id} = '$id'
EOQ;

		// Turn result query into a matrix.
		$matrix = sysdb::query2matrix($query,true);

		// Turn result matrix into vectors for processing.
		$keys = $matrix[0];
		$values = $matrix[1];

		// Specify the parameter prefix, display text, and the order of rows.
		$prefix = 'client';
		$display = array(
			'clientID' => '',
			'name' => 'Client Type Name',
			'defaults' => 'Default Parameters'
		);

		// Assemble table.
		foreach ($display as $key => $display_text) {
			$i = array_search($key, $keys);

			// Specify peculiarities of returned rows.
			if ($key == 'clientID') {
				$clientID = $values[$i];
			} else {
				$table->appendChild($tr = $doc->createElement('tr'));
				$tr->appendChild($labeltd = $doc->createElement('th'));
				$tr->appendChild($inputtd = $doc->createElement('td'));
				$labeltd->appendChild($label = $doc->createTextNode($display_text));
				$inputtd->appendChild($input = $doc->createTextNode($values[$i]));
			}
		}
  		$container->appendChild($table);

        return($container);
	}

    public function display_list($doc, $ids = '', $sort = '') {
		$query = <<<EOQ
			SELECT {$this->store->playout_client_id} AS clientID,
				{$this->store->playout_client_name} AS clientName
			FROM {$this->store->table_playout_client}
EOQ;
        $query .= " ORDER BY $sort";
        $result = sysdb::query($query);

        $table = $doc->createElement('table');
        $table->setAttribute('class','list');

        $tr = $doc->createElement('tr');
        $nametd = $doc->createElement('th');

        $nametd->appendChild(module::link_to_script_dom($doc,'Client','',array('item'=>globalize('item', get_class($this)),'action'=>'sort','sortby'=>'name'),'Client'));

        $tr->appendChild($nametd);

        $table->appendChild($tr);

        if (sysdb::num_rows($result) <= 0) {
			$tr = $doc->createElement('tr');
            $td = $doc->createElement('td');
            $td->setAttribute('colspan','2');
            $name = $doc->createTextNode('No clients entered');

            $table->appendChild($tr);
            $tr->appendChild($td);
            $td->appendChild($name);
        }
        $i = 1;
        while ($line = sysdb::fetch_assoc($result)) {
			$trStyle = module::row_style_dom($i);
			$tr = $doc->createElement('tr');
			$tr->setAttribute('class',$trStyle);

            $nametd = $doc->createElement('td');

            $nametd->appendChild(module::link_to_script_dom($doc,$line['clientName'],'',array('item'=>globalize('item', get_class($this)),'action'=>'view','id'=>$line['clientID']),'View'));

            $actiontd = $doc->createElement('td');
			$actiontd->appendChild($span = $doc->createElement('span'));
			$span->setAttribute('class', 'link_view_small');
            $span->appendChild(module::link_to_script_dom($doc,'view','',array('item'=>globalize('item', get_class($this)),'action'=>'view','id'=>$line['clientID']),'View'));
			$actiontd->appendChild($doc->createTextNode(' '));
			$actiontd->appendChild($span = $doc->createElement('span'));
			$span->setAttribute('class', 'link_edit_small');
            $span->appendChild(module::link_to_script_dom($doc,'edit','',array('item'=>globalize('item', get_class($this)),'action'=>'edit','id'=>$line['clientID']),'Edit'));
            $table->appendChild($tr);
            $tr->appendChild($nametd);
            $tr->appendChild($actiontd);
			$i++;
        }
        return($table);
    }

    public function display_select($doc, $ids = '', $default = -1) {
		$query = <<<EOQ
			SELECT {$this->store->playout_client_id} AS clientID,
				{$this->store->playout_client_name} AS name
			FROM {$this->store->table_playout_client}
EOQ;
        if (is_array($ids) && sizeof($ids) <= 0) { $query .= 'WHERE 0=1 '; } else if (is_array($ids) && sizeof($ids) > 0)
            $query .= "WHERE {$this->store->playout_client_id} IN (".implode(',',$ids).") ";
		$query .= " ORDER BY name";
        $result = sysdb::query($query);
        $select = $doc->createElement('select');
        $select->setAttribute('name', 'clientID');
        $select->setAttribute('onChange', "this.form.submit();");

        if (sysdb::num_rows($result) <= 0) {
            $option = $doc->createElement('option');
            $option->setAttribute('value', '');
            $text = $doc->createTextNode('No client types available');
            $option->appendChild($text);
			$select->appendChild($option);
        } else {
            $option = $doc->createElement('option');
			$option->setAttribute('value', '');
			$text = $doc->createTextNode('Please select an client type.');
			$option->appendChild($text);
			$select->appendChild($option);
			while ($line = sysdb::fetch_assoc($result)) {
				$option = $doc->createElement('option');
				$option->setAttribute('value', $line['clientID']);
				if ($line['clientID'] == $default)
					$option->setAttribute('selected', 'selected');
				$text = $doc->createTextNode(utf8_decode($line['name']));
				$option->appendChild($text);
				$select->appendChild($option);
			}
		}
        return($select);
    }

    public function overview($doc, $ids = '') {
        $item = globalize('item', get_class($this));
		$sortby = globalize('sortby');

		if (!isset($sortby))
			$sortby = 'name';
		else {
			switch($sortby) {
				case 'name':
							break;
				case 'client':
							$sortby = 'clientName';
							break;
				default:
							$sortby = 'clientName';
							break;
			}
		}

		$container = $doc->createElement('div');
		$container->setAttribute('class','module');

		$header = $doc->createElement('h1');
		$header->appendChild($doc->createTextNode('Client Types'));
		$container->appendChild($header);

		$container->appendChild($button = module::createButton_dom($doc, 'Import Client Type', '', array('item' => $item, 'action' => 'import'), 'Add Client Type', 'link_button', '', 'link_add'));

		$container->appendChild($button = module::createButton_dom($doc, 'Add Client Type', '', array('item' => $item, 'action' => 'edit'), 'Add Client Type', 'link_button', '', 'link_add'));

		$container->appendChild(self::display_list($doc,'',$sortby));

        return($container);
    }

    public function import($doc) {
        $item = globalize('item', get_class($this));

		$container = $doc->createElement('div');
		$container->setAttribute('class', 'module');

		$header = $doc->createElement('h1');
		$header->appendChild($doc->createTextNode('Import Client Type'));
		$container->appendChild($header);

        $table = $doc->createElement('table');
        $table->setAttribute('class', 'list');

		$class_vector = array();
		$name_vector = array();
		$description_vector = array();

		$dir = DIRECTORY_SEPARATOR;
		$path = ROOT_COMPONENTS.$dir."playout".$dir."clients";
		/* Open a known directory, and proceed to read its contents */
		if (is_dir($path)) {
			$client_list = array();
			if ($dh = opendir($path)) {
				while (($file = readdir($dh)) !== false) {
					if ($file != '.' && $file != '..' && $file != '.svn') {
						// Display the client title if it exists.
						$class_name = substr($file, 0 , -4);
						// echo 'Class name: '.$class_name.'<br/>';
						// echo 'Path: '.$path.$dir.$file.'<br/>';
						require_once($path.$dir.$file);
						// var_dump(class_exists($class_name));
						if (class_exists($class_name)) {
							// echo 'Class exists!: '.$class_name.'<br/>';
							$client_class = new $class_name();
							// var_dump($client_class);
							// var_dump(method_exists($client_class, 'getClass'));
							if (method_exists($client_class, 'getClass')) {
								$class_vector[] = $client_class->getClass();
								// echo 'getClass: '.$getClass.'<br/>';
							} else {
								$class_vector[] = '';
								// echo 'No getClass.<br/>';
							}
							if (method_exists($client_class, 'getName')) {
								$name_vector[] = $client_class->getName();
								// echo 'getName: '.$getName.'<br/>';
							} else {
								$name_vector[] = '';
								// echo 'No getName.<br/>';
							}
							if (method_exists($client_class, 'getDescription')) {
								$description_vector[] = $client_class->getDescription();
								// echo 'getDescription: '.$getDescription.'<br/>';
							} else {
								$description_vector[] = '';
								// echo 'No getDescription.<br/>';
							}
							// if (method_exists($client_class, 'getParameters')) {
								// $getParameters = $client_class->getParameters();
								// // echo 'getParameters: '.$getParameters.'<br/>';
							// } else {
								// $getParameters = '';
								// // echo 'No getParameters.<br/>';
							// }
							unset($client_class);
						}
						//array_push($client_list, $file);
					}
				}
				closedir($dh);
			}
		}

		// Arrange data so that each column is a vector within the matrix.
		$matrix = array($class_vector, $name_vector, $description_vector);
		$vectors = sysdb::rotatematrix($matrix);

		// Assemble table.
        $table->appendChild($tr = $doc->createElement('tr'));
        $tr->appendChild($classth = $doc->createElement('th'));
		$classth->appendChild($input = $doc->createTextNode('Class'));
        $tr->appendChild($nameth = $doc->createElement('th'));
		$nameth->appendChild($input = $doc->createTextNode('Client Name'));
        $tr->appendChild($descth = $doc->createElement('th'));
		$descth->appendChild($input = $doc->createTextNode('Description'));

        if (sizeof($vectors) <= 0) {
			$tr = $doc->createElement('tr');
            $td = $doc->createElement('td');
            $td->setAttribute('colspan','3');
            $name = $doc->createTextNode('No clients found');

            $table->appendChild($tr);
            $tr->appendChild($td);
            $td->appendChild($name);
        }
		for($i = 0; $i < sizeof($vectors); $i++) {
			$trStyle = module::row_style_dom($i);
			$table->appendChild($tr = $doc->createElement('tr'));
			$tr->setAttribute('class', $trStyle);

            $tr->appendChild($classtd = $doc->createElement('td'));
            $tr->appendChild($nametd = $doc->createElement('td'));
            $tr->appendChild($desctd = $doc->createElement('td'));

			$classtd->appendChild($input = $doc->createTextNode($vectors[$i][0]));
			$nametd->appendChild($input = $doc->createTextNode($vectors[$i][1]));
			$desctd->appendChild($input = $doc->createTextNode($vectors[$i][2]));

            $tr->appendChild($actiontd = $doc->createElement('td'));
			$actiontd->appendChild($span = $doc->createElement('span'));
			$span->setAttribute('class', 'link_ingest_small');
            $span->appendChild(module::link_to_script_dom($doc, 'Import', '', array('item' => $item, 'action' => 'template', 'id' => $vectors[$i][0]), 'Import'));
        }
 		$container->appendChild($table);

        return($container);
    }

    public function template($doc, $id = '') {
        $item = globalize('item', get_class($this));

		$container = $doc->createElement('div');
		$container->setAttribute('class', 'module');

		$header = $doc->createElement('h1');
		$header->appendChild($doc->createTextNode('Importing Client Type'));
		$container->appendChild($header);

        $table = $doc->createElement('table');
        $table->setAttribute('class', 'view');

		$class_vector = array();
		$name_vector = array();
		$description_vector = array();
		$parameter_vector = array();

		$dir = DIRECTORY_SEPARATOR;
		$path = ROOT_COMPONENTS.$dir."playout".$dir."clients";
		/* Open a known directory, and proceed to read its contents */
		if (is_dir($path)) {
			$client_list = array();
			if ($dh = opendir($path)) {
				require_once($path.$dir.$id.".php");
				// var_dump(class_exists($class_name));
				if (class_exists($id)) {
					// echo 'Class exists!: '.$class_name.'<br/>';
					$client_class = new $id();
					// var_dump($client_class);
					// var_dump(method_exists($client_class, 'getClass'));
					if (method_exists($client_class, 'getClass')) {
						$class_vector[] = $client_class->getClass();
						// echo 'getClass: '.$getClass.'<br/>';
					} else {
						$class_vector[] = '';
						// echo 'No getClass.<br/>';
					}
					if (method_exists($client_class, 'getName')) {
						$name_vector[] = $client_class->getName();
						// echo 'getName: '.$getName.'<br/>';
					} else {
						$name_vector[] = '';
						// echo 'No getName.<br/>';
					}
					if (method_exists($client_class, 'getDescription')) {
						$description_vector[] = $client_class->getDescription();
						// echo 'getDescription: '.$getDescription.'<br/>';
					} else {
						$description_vector[] = '';
						// echo 'No getDescription.<br/>';
					}
					if (method_exists($client_class, 'getParameters')) {
						$parameter_vector[] = $client_class->getParameters();
						// echo 'getParameters: '.$getParameters.'<br/>';
					} else {
						$parameter_vector[] = '';
						// echo 'No getParameters.<br/>';
					}
					unset($client_class);
				}
				closedir($dh);
			}
		}

		// Specify the parameter prefix, display text, and the order of rows.
		$prefix = 'client';
		$display = array(
			'class' => '',
			'name' => 'Client Type Name',
			'description' => 'Description',
			'parameters' => 'Parameters (specify defaults)'
		);

		// Arrange data so that each column is a vector within the matrix.
		$matrix = array($class_vector, $name_vector, $description_vector, $parameter_vector);
		$vectors = sysdb::rotatematrix($matrix);

		$keys = array_keys($display);
		$values = $vectors[0];
// print_r($values);


		// Assemble table.
		foreach ($display as $key => $display_text) {
			$i = array_search($key, $keys);

			// Specify peculiarities of returned rows.
			if ($key == 'class') {
				$class = $values[$i];
				$table->appendChild($client = $doc->createElement('input'));
				$client->setAttribute('type', 'hidden');
				$client->setAttribute('name', $prefix.ucfirst($key));
				$client->setAttribute('value', $values[$i]);
			} else if ($key == 'name') {
				$table->appendChild($tr = $doc->createElement('tr'));
				$tr->appendChild($labeltd = $doc->createElement('th'));
				$tr->appendChild($inputtd = $doc->createElement('td'));
				$labeltd->appendChild($label = $doc->createTextNode($display_text));
				$inputtd->appendChild($label = $doc->createTextNode($values[$i]));
				// $inputtd->appendChild(module::link_to_script_dom($doc,$values[$i], '', array('item' => 'Client', 'action' => 'view', 'id' => $class), 'View'));
			} else if ($key == 'parameters') {
				$table->appendChild($tr = $doc->createElement('tr'));
				$tr->appendChild($labeltd = $doc->createElement('th'));
				$tr->appendChild($inputtd = $doc->createElement('td'));
				$labeltd->appendChild($label = $doc->createTextNode($display_text));
				$inputtd->appendChild($div = $doc->createElement('div'));

				$div->appendChild($inner = $doc->createElement('table'));
				$inner->setAttribute('class', 'view');

				$param_keys = $values[$i]['keys'];
				$param_defaults = $values[$i]['defaults'];
				$param_types = $values[$i]['type'];
				$param_desc = $values[$i]['descriptions'];

				// Display the default parameters for the client type.
				foreach($param_keys as $j => $param) {
					$inner->appendChild($tr = $doc->createElement('tr'));
					$tr->appendChild($labeltd = $doc->createElement('th'));
					$tr->appendChild($inputtd = $doc->createElement('td'));
					$labeltd->appendChild($label = $doc->createTextNode($param_keys[$j]));

					if ($param_types[$j] == 'boolean') {
						// Display a checkbox for boolean values.
						$inputtd->appendChild($input = $doc->createElement('input'));
						$input->setAttribute('type', 'checkbox');
						$input->setAttribute('name', $prefix.ucfirst($param_keys[$j]));
						if ($param_defaults[$j])
							$input->setAttribute('checked', 'yes');
					} else {
						$inputtd->appendChild($input = $doc->createElement('input'));
						$input->setAttribute('type', 'text');
						$input->setAttribute('name', $prefix.ucfirst($param_keys[$j]));
						$input->setAttribute('value', $param_defaults[$j]);
					}
					$tr->appendChild($annotd = $doc->createElement('td'));
					$annotd->appendChild($desc = $doc->createTextNode($param_desc[$j]));
				}
			} else {
				$table->appendChild($tr = $doc->createElement('tr'));
				$tr->appendChild($labeltd = $doc->createElement('th'));
				$tr->appendChild($inputtd = $doc->createElement('td'));
				$labeltd->appendChild($label = $doc->createTextNode($display_text));
				$inputtd->appendChild($input = $doc->createTextNode($values[$i]));
			}
		}

        $savetr = $doc->createElement('tr');
        $savetd = $doc->createElement('td');
        $save = $doc->createElement('input');
        $save->setAttribute('type', 'submit');
        $save->setAttribute('name', 'action');
        $save->setAttribute('value', 'create');
        $savetd->appendChild($save);
        $savetr->appendChild($savetd);
        $table->appendChild($savetr);

 		$container->appendChild($table);

        return($container);
    }

    public function create($class) {
		$item = globalize('item', get_class($this));

		$prefix = 'client';
		$dir = DIRECTORY_SEPARATOR;
		$path = ROOT_COMPONENTS.$dir."playout".$dir."clients";
		/* Open a known directory, and proceed to read its contents */
		if (is_dir($path)) {
			$client_list = array();
			if ($dh = opendir($path)) {
				require_once($path.$dir.$class.".php");
				// var_dump(class_exists($class_name));
				if (class_exists($class)) {
					// echo 'Class exists!: '.$class_name.'<br/>';
					$client_class = new $class();
					if (method_exists($client_class, 'getName')) {
						$name = $client_class->getName();
						// echo 'getName: '.$getName.'<br/>';
					} else {
						$name = '';
						// echo 'No getName.<br/>';
					}
					if (method_exists($client_class, 'getParameters')) {
						$parameters = $client_class->getParameters();
						// echo 'getParameters: '.$getParameters.'<br/>';
					} else {
						$parameters = array();
						// echo 'No getParameters.<br/>';
					}
					unset($client_class);
				}
				closedir($dh);
			}
		} else {
			die("error");
		}
		
		$defaults = "";
		$i = 0;
		foreach ($parameters['keys'] as $key => $value) {
			if ($i > 0)
				$defaults .= ", ";
			$defaults .= "'".$value."' => '".globalize($prefix.ucfirst($value))."'"; 
			$i++;
		}
		
		$this->add($name, $defaults);
	}

    public function add($name, $defaults) {
		$item = globalize('item', get_class($this));

		// Escape values.
		$values = array(&$name,
						&$defaults
						);
 		foreach ($values as &$value) {
			$value = sysdb::escape_string($value);
			$value = utf8_encode($value);
		}
		unset($value);

        $query = <<<EOQ
			INSERT INTO {$this->store->table_playout_client} (
				{$this->store->playout_client_name},
				{$this->store->playout_client_defaults}
			) VALUES (
				'$name',
				'$defaults'
			)
EOQ;
		sysdb::query($query);
		state::setMessage('notify', 'Successfully added new playout client type: '.utf8_decode($name));
		$clientID = sysdb::insert_id();
		module::forward_to_script('', array('item' => $item, 'action' => 'view', 'id' => $clientID));
	}

    public function save($id, $name, $defaults) {
		$item = globalize('item', get_class($this));

		// Escape values.
		$values = array(&$name,
						&$defaults
						);
 		foreach ($values as &$value) {
			$value = sysdb::escape_string($value);
			$value = utf8_encode($value);
		}
		unset($value);

		$query = <<<EOQ
			UPDATE {$this->store->table_playout_client}
			SET {$this->store->playout_client_name} = '$name',
				{$this->store->playout_client_defaults} = '$defaults'
			WHERE {$this->store->playout_client_id} = '$id'
EOQ;
		sysdb::query($query);
		state::setMessage('notify', 'Successfully updated playout client type: '.utf8_decode($name));
		module::forward_to_script('', array('item' => $item, 'action' => 'view', 'id' => $id));
	}

    public function delete($id) {
        $query = <<<EOQ
			SELECT {$this->store->playout_client_name}
			FROM {$this->store->table_playout_client}
			WHERE {$this->store->playout_client_id} = '$id'
EOQ;
		$name = sysdb::queryOne($query);

		$query = <<<EOQ
			DELETE FROM {$this->store->table_playout_client}
			WHERE {$this->store->playout_client_id} = '$id'
EOQ;
		sysdb::query($query);
		state::setMessage('notify', 'Successfully deleted playout client type: '.utf8_decode($name));
    }

    public function remove($id) {
		// The core message display uses 'echo' type page assembly instead of DOMDocument.
        $item = globalize('item', get_class($this));
		$message = '<p>Are you really sure you want to delete this playout client type item?</p>';
		$message .= '<div class="message_buttons">';
		$message .= '<div class="left">';
		$message .= '<span class="link_button">';
		$message .= '<a href="';
		$message .= module::link_to_script('Yes, Delete', '', array('item' => $item, 'action' => 'delete', 'id' => $id), false, false, 'Yes, Delete', 'link_button');
		$message .= '" title="Delete" class="link_button">';
		$message .= '<span class="link_delete">Yes, Delete</span>';
		$message .= '</a>';
		$message .= '</span>';
		$message .= '</div>';
		$message .= '<div class="right">';
		$message .= '<span class="link_button">';
		$message .= '<a href="';
		$message .= module::link_to_script('Cancel', '', array('item' => $item, 'action' => 'cancel', 'id' => $id), false, false, 'Cancel', 'link_button');
		$message .= '" title="Cancel" class="link_button">';
		$message .= '<span class="link_delete">Cancel</span>';
		$message .= '</a>';
		$message .= '</span>';
		$message .= '</div>';
		$message .= '</div>';
		state::setMessage('warning', $message);
		return;
    }

    public function cancel($id) {
		// Cancel remove action and return to edit page.
        $item = globalize('item', get_class($this));
        module::forward_to_script('',array('item'=>$item,'action'=>'edit','id'=>$id));
		return;
    }

    public function search($doc, $string) {
        $string = strtolower($string);
        $query = "SELECT {$this->store->playout_client_id} FROM {$this->store->table_playout_client} WHERE LCASE({$this->store->playout_client_name}) LIKE '%$string%' ";
        $result = sysdb::query($query);

        if (sysdb::num_rows($result) <= 0) {
            $empty = $doc->createElement('span');
            return($empty);
        } else {
            return($this->display_list($doc, sysdb::result2vector($result, 'id')));
        }
    }

}
?>