<?php
// $Id$

class Install {
	var $store;

	function __construct() {
		$this->store = new playoutStorage();
	}

    public function actions() {
        switch(globalize('action')) {
            case 'delete':
				$this->delete(globalize('id'));
				break;
            case 'add':
				$this->add(globalize('clientID'),
							globalize('installName'),
							globalize('installParams'));
				break;
            case 'save':
				$this->save(globalize('installID'),
							globalize('installClientID'),
							globalize('installName'),
							globalize('installParams'));
				break;
            case "remove":
				$this->remove(globalize('id'));
				break;
            case "submit":
				$this->submit(globalize('clientID'));
				break;
            case "cancel":
				$this->cancel(globalize('id'));
				break;
        }
    }

    public function button_edit($doc, $id = '') {
        $item = globalize('item', get_class($this));

		$spanbutton = $doc->createElement('span');
		$spanbutton->setAttribute('class', 'link_button');
		$spanbutton->appendChild($a = module::link_to_script_dom_unappended($doc, 'Edit', '', array('item' => $item, 'action' => 'edit', 'id' => $id), 'Edit', 'link_button'));
		$a->appendChild($span = $doc->createElement('span'));
		$span->setAttribute('class', 'link_edit');
		$span->appendChild($label = $doc->createTextNode('Edit'));

        return($spanbutton);
	}

    public function button_delete($doc, $id = '') {
        $item = globalize('item', get_class($this));

		$spanbutton = $doc->createElement('span');
		$spanbutton->setAttribute('class', 'link_button');
		$spanbutton->appendChild($a = module::link_to_script_dom_unappended($doc, 'Delete', '', array('item' => $item, 'action' => 'remove', 'id' => $id), 'Delete', 'link_button'));
		$a->appendChild($span = $doc->createElement('span'));
		$span->setAttribute('class', 'link_delete');
		$span->appendChild($label = $doc->createTextNode('Delete'));

        return($spanbutton);
	}

    public function form($doc, $id = '') {

		if ($id != '') {
			$status = 'true';
		} else {
			$returnedClientID = globalize('clientID');
			if ($returnedClientID != '') $status = 'true';
			else $status = '';
		}

		$container = $doc->createElement('div');
		$container->setAttribute('class', 'module');

		if ($id == '')
            $headerText = 'Add Client Installation';
        else
            $headerText = 'Edit Client Installation';

		$header = $doc->createElement('h1');
		$header->appendChild($doc->createTextNode($headerText));
		$container->appendChild($header);

		/* This input is to end execution of the module index file.
			Because we are forwarding to another page each time we add or save,
			we need to make sure the page doesn't get generated twice */
		$terminate = $doc->createElement('input');
		$terminate->setAttribute('type', 'hidden');
		$terminate->setAttribute('name', 'terminate');
		$terminate->setAttribute('value', 'true');
		$container->appendChild($terminate);

        $installIDinput = $doc->createElement('input');
        $installIDinput->setAttribute('type', 'hidden');
        $installIDinput->setAttribute('name', 'installID');
        $installIDinput->setAttribute('value', $id);
        $container->appendChild($installIDinput);

		// Specify the parameter prefix, display text, and the order of rows.
		$prefix = 'install';
		if ($status != '') {
			$display = array(
				'clientID' => '',
				'defaults' => '',
				'clientName' => 'Client Type *',
				'name' => 'Installation Name *',
				'params' => 'Parameters'
			);
		} else {
			$display = array(
				'clientID' => '',
				'clientName' => 'Client Type *'
			);
		}

        if ($id != '') {
			$query = <<<EOQ
				SELECT DISTINCT I.{$this->store->playout_install_id} AS installID,
					I.{$this->store->playout_install_name} AS name,
					I.{$this->store->playout_install_params} AS params,
					C.{$this->store->playout_client_id} AS clientID,
					C.{$this->store->playout_client_name} AS clientName,
					C.{$this->store->playout_client_defaults} AS defaults
				FROM ({$this->store->table_playout_install} I,
					{$this->store->table_playout_client} C
				)
				WHERE I.{$this->store->playout_install_id} = '$id'
				AND I.{$this->store->playout_install_client} = C.{$this->store->playout_client_id}
EOQ;

			// Turn result query into a matrix.
			$matrix = sysdb::query2matrix($query,true);

			// Turn result matrix into vectors for processing.
			$keys = $matrix[0];
			$values = $matrix[1];

			$container->appendChild($deletebutton = $this->button_delete($doc, $id));
		} else {
			// Create blank arrays so that table will build.
			$keys = array_keys($display);
			$values = array();
			for($j = 0; $j < sizeof($keys); $j++) {
				$values[] = '';
			}

			// Merge defaults into array.
			if ($status != '') {
				$query = <<<EOQ
					SELECT {$this->store->playout_client_defaults} AS defaults
					FROM {$this->store->table_playout_client}
					WHERE {$this->store->playout_client_id} = '$returnedClientID'
EOQ;
				// Place result query into array at correct spot.
				$values[array_search('defaults', $keys)] = sysdb::queryOne($query);
			}
		}

        $table = $doc->createElement('table');
        $table->setAttribute('class', 'view');

		// Assemble table.
		foreach ($display as $key => $display_text) {
			$i = array_search($key, $keys);

			// Specify peculiarities of returned rows.
			if ($key == 'clientID') {
				$clientID = $values[$i];
				$table->appendChild($client = $doc->createElement('input'));
				$client->setAttribute('type', 'hidden');
				$client->setAttribute('name', $prefix.ucfirst($key));
				$client->setAttribute('value', $values[$i]);
			} else if ($key == 'defaults') {
				$defaults = $values[$i];
			} else if ($key == 'clientName') {
				$table->appendChild($tr = $doc->createElement('tr'));
				$tr->appendChild($labeltd = $doc->createElement('th'));
				$tr->appendChild($inputtd = $doc->createElement('td'));
				$labeltd->appendChild($label = $doc->createTextNode($display_text));
				if ($id != '') {
					$inputtd->appendChild(module::link_to_script_dom($doc, $values[$i], '', array('item' => 'Client', 'action' => 'view', 'id' => $clientID), 'View'));
				} else {
					// $table->appendChild($statusinput = $doc->createElement('input'));
					// $statusinput->setAttribute('type', 'hidden');
					// $statusinput->setAttribute('name', 'status');
					// $statusinput->setAttribute('value', 'true');

					$table->appendChild($actioninput = $doc->createElement('input'));
					$actioninput->setAttribute('type', 'hidden');
					$actioninput->setAttribute('name', 'action');
					$actioninput->setAttribute('value', 'submit');

					$clientObj = new Client();
					$inputtd->appendChild($input = $clientObj->display_select($doc, '', $returnedClientID));
				}
			} else if ($key == 'params') {
				$table->appendChild($tr = $doc->createElement('tr'));
				$tr->appendChild($labeltd = $doc->createElement('th'));
				$tr->appendChild($inputtd = $doc->createElement('td'));
				$labeltd->appendChild($label = $doc->createTextNode($display_text));
				$inputtd->appendChild($textarea = $doc->createElement('textarea'));
				$textarea->setAttribute('cols', 50);
				$textarea->setAttribute('rows', 8);
				$textarea->setAttribute('name', $prefix.ucfirst($key));
				if ($id != '') {
					$textarea->appendChild($text = $doc->createTextNode($values[$i]));
				} else {
					$textarea->appendChild($text = $doc->createTextNode($defaults));
				}
			} else {
				$table->appendChild($tr = $doc->createElement('tr'));
				$tr->appendChild($labeltd = $doc->createElement('th'));
				$tr->appendChild($inputtd = $doc->createElement('td'));
				$labeltd->appendChild($label = $doc->createTextNode($display_text));
				$inputtd->appendChild($input = $doc->createElement('input'));
				$input->setAttribute('type', 'text');
				$input->setAttribute('name', $prefix.ucfirst($key));
				$input->setAttribute('value', $values[$i]);
			}
		}

		if ($status != '') {
			$savetr = $doc->createElement('tr');
			$savetd = $doc->createElement('td');
			$save = $doc->createElement('input');
			$save->setAttribute('type', 'submit');
			$save->setAttribute('name', 'action');
			if ($id == '')
				$save->setAttribute('value', 'add');
			else
				$save->setAttribute('value', 'save');
			$savetd->appendChild($save);
			$savetr->appendChild($savetd);
			$table->appendChild($savetr);
		}

		$container->appendChild($table);

        return($container);
    }

    public function view($doc, $id = '') {

		$container = $doc->createElement('div');
		$container->setAttribute('class', 'module');
		$container->appendChild($header = $doc->createElement('h1'));
		$header->appendChild($doc->createTextNode('View Client Installation'));

		$container->appendChild($editbutton = $this->button_edit($doc, $id));

        $table = $doc->createElement('table');
        $table->setAttribute('class', 'view');

		$query = <<<EOQ
			SELECT DISTINCT I.{$this->store->playout_install_id} AS installID,
				I.{$this->store->playout_install_name} AS name,
				I.{$this->store->playout_install_params} AS params,
				C.{$this->store->playout_client_id} AS clientID,
				C.{$this->store->playout_client_name} AS clientName
			FROM ({$this->store->table_playout_install} I,
				{$this->store->table_playout_client} C
			)
			WHERE I.{$this->store->playout_install_id} = '$id'
			AND I.{$this->store->playout_install_client} = C.{$this->store->playout_client_id}
EOQ;

		// Turn result query into a matrix.
		$matrix = sysdb::query2matrix($query,true);

		// Turn result matrix into vectors for processing.
		$keys = $matrix[0];
		$values = $matrix[1];

		// Specify the parameter prefix, display text, and the order of rows.
		$prefix = 'install';
		$display = array(
			'clientID' => '',
			'clientName' => 'Client Type',
			'name' => 'Installation Name',
			'params' => 'Parameters'
		);

		// Assemble table.
		foreach ($display as $key => $display_text) {
			$i = array_search($key, $keys);

			// Specify peculiarities of returned rows.
			if ($key == 'clientID') {
				$clientID = $values[$i];
			} else if ($key == 'clientName') {
				$table->appendChild($tr = $doc->createElement('tr'));
				$tr->appendChild($labeltd = $doc->createElement('th'));
				$tr->appendChild($inputtd = $doc->createElement('td'));
				$labeltd->appendChild($label = $doc->createTextNode($display_text));
				$inputtd->appendChild(module::link_to_script_dom($doc,$values[$i], '', array('item' => 'Client', 'action' => 'view', 'id' => $clientID), 'View'));
			} else {
				$table->appendChild($tr = $doc->createElement('tr'));
				$tr->appendChild($labeltd = $doc->createElement('th'));
				$tr->appendChild($inputtd = $doc->createElement('td'));
				$labeltd->appendChild($label = $doc->createTextNode($display_text));
				$inputtd->appendChild($input = $doc->createTextNode($values[$i]));
			}
		}
  		$container->appendChild($table);

        return($container);
	}

    public function display_list($doc, $ids = '', $sort = '') {
		$query = <<<EOQ
			SELECT DISTINCT I.{$this->store->playout_install_id} AS installID,
				I.{$this->store->playout_install_name} AS installName,
				C.{$this->store->playout_client_id} AS clientID,
				C.{$this->store->playout_client_name} AS clientName
			FROM ({$this->store->table_playout_install} I,
				{$this->store->table_playout_client} C
			)
			WHERE I.{$this->store->playout_install_client} = C.{$this->store->playout_client_id}
EOQ;
        $query .= " ORDER BY $sort";
        $result = sysdb::query($query);

        $table = $doc->createElement('table');
        $table->setAttribute('class', 'list');

        $tr = $doc->createElement('tr');
        $nametd = $doc->createElement('th');
        $clienttd = $doc->createElement('th');

        $nametd->appendChild(module::link_to_script_dom($doc,'Install', '',array('item'=>globalize('item', get_class($this)),'action'=>'sort', 'sortby'=>'name'),'Install'));
		$clienttd->appendChild(module::link_to_script_dom($doc,'Client', '',array('item'=>globalize('item', get_class($this)),'action'=>'sort', 'sortby'=>'client'),'Client'));

        $tr->appendChild($nametd);
        $tr->appendChild($clienttd);

        $table->appendChild($tr);

        if (sysdb::num_rows($result) <= 0) {
			$tr = $doc->createElement('tr');
            $td = $doc->createElement('td');
            $td->setAttribute('colspan', '2');
            $name = $doc->createTextNode('No installs entered');

            $table->appendChild($tr);
            $tr->appendChild($td);
            $td->appendChild($name);
        }
        $i = 1;
        while ($line = sysdb::fetch_assoc($result)) {
			$trStyle = module::row_style_dom($i);
			$tr = $doc->createElement('tr');
			$tr->setAttribute('class',$trStyle);

            $nametd = $doc->createElement('td');
            $clienttd = $doc->createElement('td');

            $nametd->appendChild(module::link_to_script_dom($doc,$line['installName'],'',array('item'=>globalize('item', get_class($this)),'action'=>'view', 'id'=>$line['installID']),'View'));
            $clienttd->appendChild(module::link_to_script_dom($doc,$line['clientName'],'',array('item'=>'Client', 'action'=>'view', 'id'=>$line['clientID']),'View'));

            $actiontd = $doc->createElement('td');
			$actiontd->appendChild($span = $doc->createElement('span'));
			$span->setAttribute('class', 'link_view_small');
            $span->appendChild(module::link_to_script_dom($doc,'view', '',array('item'=>globalize('item', get_class($this)),'action'=>'view', 'id'=>$line['installID']),'View'));
			$actiontd->appendChild($doc->createTextNode(' '));
			$actiontd->appendChild($span = $doc->createElement('span'));
			$span->setAttribute('class', 'link_edit_small');
            $span->appendChild(module::link_to_script_dom($doc,'edit', '',array('item'=>globalize('item', get_class($this)),'action'=>'edit', 'id'=>$line['installID']),'Edit'));
            $table->appendChild($tr);
            $tr->appendChild($nametd);
            $tr->appendChild($clienttd);
            $tr->appendChild($actiontd);
			$i++;
        }
        return($table);
    }

    public function display_select($doc, $ids = '', $default = -1) {
		$query = <<<EOQ
			SELECT {$this->store->playout_install_id} AS installID,
				{$this->store->playout_install_name} AS name
			FROM {$this->store->table_playout_install}
EOQ;
        if (is_array($ids) && sizeof($ids) <= 0) { $query .= 'WHERE 0=1 '; } else if (is_array($ids) && sizeof($ids) > 0)
            $query .= "WHERE {$this->store->playout_install_id} IN (".implode(',',$ids).") ";
		$query .= " ORDER BY name";
        $result = sysdb::query($query);
        $select = $doc->createElement('select');
        $select->setAttribute('name', 'installID');

        if (sysdb::num_rows($result) <= 0) {
            $option = $doc->createElement('option');
            $option->setAttribute('value', '');
            $text = $doc->createTextNode('No installations available');
            $option->appendChild($text);
			$select->appendChild($option);
        } else {
            $option = $doc->createElement('option');
			$option->setAttribute('value', '');
			$text = $doc->createTextNode('Please select an installation.');
			$option->appendChild($text);
			$select->appendChild($option);
			while ($line = sysdb::fetch_assoc($result)) {
				$option = $doc->createElement('option');
				$option->setAttribute('value',$line['installID']);
				if ($line['installID'] == $default)
					$option->setAttribute('selected', 'selected');
				$text = $doc->createTextNode(utf8_decode($line['name']));
				$option->appendChild($text);
				$select->appendChild($option);
			}
		}
        return($select);
    }

    public function overview($doc, $ids = '') {
        $item = globalize('item', get_class($this));
		$sortby = globalize('sortby');

		if (!isset($sortby))
			$sortby = 'name';
		else {
			switch($sortby) {
				case 'name':
							break;
				case 'client':
							$sortby = 'clientName';
							break;
				default:
							$sortby = 'installName';
							break;
			}
		}

		$container = $doc->createElement('div');
		$container->setAttribute('class', 'module');

		$header = $doc->createElement('h1');
		$header->appendChild($doc->createTextNode('Client Installations'));
		$container->appendChild($header);

		$container->appendChild($button = module::createButton_dom($doc, 'Add Installation', '', array('item'=>$item,'action'=>'edit'), 'Add Installation', 'link_button', '', 'link_add'));

		$container->appendChild(self::display_list($doc,'',$sortby));

        return($container);
    }

    public function add($clientID, $name, $parameters) {
		$item = globalize('item', get_class($this));

		// Escape values.
		$values = array(&$name,
						&$parameters
						);
 		foreach ($values as &$value) {
			$value = sysdb::escape_string($value);
			$value = utf8_encode($value);
		}
		unset($value);

        $query = <<<EOQ
			INSERT INTO {$this->store->table_playout_install} (
				{$this->store->playout_install_client},
				{$this->store->playout_install_name},
				{$this->store->playout_install_params}
			) VALUES (
				'$clientID',
				'$name',
				'$parameters'
			)
EOQ;
		sysdb::query($query);
		state::setMessage('notify', 'Successfully added new playout installation: '.utf8_decode($name));
		$installID = sysdb::insert_id();
		module::forward_to_script('', array('item' => $item, 'action' => 'view', 'id' => $installID));
	}

    public function save($id, $clientID, $name, $parameters) {
		$item = globalize('item', get_class($this));

		// Escape values.
		$values = array(&$name,
						&$parameters
						);
 		foreach ($values as &$value) {
			$value = sysdb::escape_string($value);
			$value = utf8_encode($value);
		}
		unset($value);

		$query = <<<EOQ
			UPDATE {$this->store->table_playout_install}
			SET {$this->store->playout_install_client} = '$clientID',
				{$this->store->playout_install_name} = '$name',
				{$this->store->playout_install_params} = '$parameters'
			WHERE {$this->store->playout_install_id} = '$id'
EOQ;
		sysdb::query($query);
		state::setMessage('notify', 'Successfully updated playout installation: '.utf8_decode($name));
		module::forward_to_script('', array('item' => $item, 'action' => 'view', 'id' => $id));
	}

    public function delete($id) {
        $query = <<<EOQ
			SELECT {$this->store->playout_install_name}
			FROM {$this->store->table_playout_install}
			WHERE {$this->store->playout_install_id} = '$id'
EOQ;
		$name = sysdb::queryOne($query);

		$query = <<<EOQ
			DELETE FROM {$this->store->table_playout_install}
			WHERE {$this->store->playout_install_id} = '$id'
EOQ;
		sysdb::query($query);
		state::setMessage('notify', 'Successfully deleted playout installation: '.utf8_decode($name));
    }

    public function remove($id) {
		// The core message display uses 'echo' type page assembly instead of DOMDocument.
        $item = globalize('item', get_class($this));
		$message = '<p>Are you really sure you want to delete this playout installation item?</p>';
		$message .= '<div class="message_buttons">';
		$message .= '<div class="left">';
		$message .= '<span class="link_button">';
		$message .= '<a href="';
		$message .= module::link_to_script('Yes, Delete', '', array('item' => $item, 'action' => 'delete', 'id' => $id), false, false, 'Yes, Delete', 'link_button');
		$message .= '" title="Delete" class="link_button">';
		$message .= '<span class="link_delete">Yes, Delete</span>';
		$message .= '</a>';
		$message .= '</span>';
		$message .= '</div>';
		$message .= '<div class="right">';
		$message .= '<span class="link_button">';
		$message .= '<a href="';
		$message .= module::link_to_script('Cancel', '', array('item' => $item, 'action' => 'cancel', 'id' => $id), false, false, 'Cancel', 'link_button');
		$message .= '" title="Cancel" class="link_button">';
		$message .= '<span class="link_delete">Cancel</span>';
		$message .= '</a>';
		$message .= '</span>';
		$message .= '</div>';
		$message .= '</div>';
		state::setMessage('warning', $message);

		return;
    }

    public function submit($id) {
		// Return to edit page.
        $item = globalize('item', get_class($this));
        module::forward_to_script('', array('item' => $item, 'action' => 'edit', 'clientID' => $id));
		// return;
    }

    public function cancel($id) {
		// Cancel remove action and return to edit page.
        $item = globalize('item', get_class($this));
        module::forward_to_script('',array('item'=>$item,'action'=>'edit', 'id'=>$id));
		return;
    }

    public function search($doc, $string) {
        $string = strtolower($string);
        $query = "SELECT {$this->store->playout_install_id} FROM {$this->store->table_playout_install} WHERE LCASE({$this->store->playout_install_name}) LIKE '%$string%' ";
        $result = sysdb::query($query);

        if (sysdb::num_rows($result) <= 0) {
            $empty = $doc->createElement('span');
            return($empty);
        } else {
            return($this->display_list($doc, sysdb::result2vector($result, 'id')));
        }
    }

}
?>