<?php
// $Id$

/**
* Describes the Flywire playout client requirements to the Retromod playout module.
*
* @fn getClass()
*   Returns the name of this class.
* @fn getName()
*   Returns the name of this playout client.
* @fn getDescription()
*   Returns a description of this playout client.
* @fn getClass()
*   Returns an associative array of the parameters required by this playout client.
*/
class Flywire {

	/** Returns the name of this class. */
    public function getClass() {
		return get_class($this);
	}

	/** Returns the name of this playout client. */
    public function getName() {
		$name = "Bentokit Flywire";
		return $name;
	}

	/** Returns a description of this playout client. */
    public function getDescription() {
		$description = "Flywire is an open source playout client for the community broadcasting sector. It is freely available from http://bentokit.org";
		return $description;
	}

	/** Returns an associative array of the parameters required by this playout client. */
    public function getParameters() {
        $keys = array(
            0 => 'ip',
            1 => 'schedule_path',
            2 => 'media_path',
            3 => 'log_path',
            4 => 'username',
            5 => 'onair'
        );
        $defaults = array(
            0 => '10.1.1.1',
            1 => '/home/retromod/flywire/Schedule',
            2 => '/home/retromod/flywire/ScheduledMedia',
            3 => '/home/retromod/flywire/Log',
            4 => 'retromod',
            5 => '1'
        );
        $type = array(
            0 => 'text',
            1 => 'text',
            2 => 'text',
            3 => 'text',
            4 => 'text',
            5 => 'boolean'
        );
        $descriptions = array(
            0 => 'IP address of the remote client machine',
            1 => 'Path to the schedule directory on the remote client machine',
            2 => 'Path to the scheduled media directory on the remote client machine',
            3 => 'Path to the log directory on the remote client machine',
            4 => 'Username for ssh/rsync on the remote client machine',
            5 => 'Archive the played logs on this machine, e.g. the remote client is playing sponsorship live to air'
        );
        return(array('keys' => $keys, 'defaults' => $defaults, 'type' => $type, 'descriptions' => $descriptions));
    }

}
?>