<?php
// $Id$

include_once('moduleconfig.php');

if (!isset($module_parameter)) $module_parameter = array();
//print_r($module_parameter);

function __autoload($class_name) {
    require_once $class_name . '.php';
}

$g = array('item','action','id','playout_search','playout_search_action',
           'relationship_action'=>'r_action');
extract(globalize_many($g));

$class = run_item_actions($item);

if (globalize('terminate') == 'true')
	exit;

// Perform relationship actions first.
if ($r_action != '') {
    foreach($r_action as $name=>$value) {
        $r_class = new $name();
        $r_class->actions();
    }
}

$accessPlayout = array('viewPlayout', 'addPlayout', 'editPlayout', 'adminPlayout');

$access = array(
	'Client' => $accessPlayout,
	'Install' => $accessPlayout
	);

$menu_labels = array(
	'Client'=>'Clients',
	'Install'=>'Installations'
	);


/* ==== Access Control ==== */

$menu_items['Module Home'] = array('item'=>'');
$acl = module::parameter_table($module_parameter, $access, 0);
//print_r($acl);
foreach($acl as $key=>$val) {
   if(($val) AND (isset($menu_labels[$key])) ) {
      $menu_items[$menu_labels[$key]] = array('item'=>$key);
	}
}


/* ==== Begin GUI/Interface Code ==== */
$doc = new DOMDocument();
//$doc->substituteEntities = false;
$doc->formatOutput = true;

$highlight = '';
$i=0;
foreach($menu_items as $key=>$val) {
	if($val['item'] == $item) {
		$highlight=$i;
	}
	$i++;
}

$doc->appendChild(dom::createMenu($doc,$menu_items,'module_menu',$highlight));

if((isset($playout_search_action)) AND ($playout_search_action=='search')) {  $do='search'; }
if($item!='') { $do='item'; }
if((!isset($do)) OR ($do=='')) { $do='home'; }

$headers = array();
switch($do) {
	/* Do a global search across the component */
	case 'search':
		$doc->appendChild($container = $doc->createElement('div'));
		$container->setAttribute('class','module');

		$container->appendChild($header = $doc->createElement('h1'));
		$header->appendChild($doc->createTextNode('Search Results'));

		$container->appendChild($header = $doc->createElement('h2'));
		$header->appendChild($doc->createTextNode('Results for "'.$playout_search.'"'));

		foreach($global_search_items as $object) {
			$o_class = new $object();
			if (method_exists($o_class,'search')) {
				// Give each search return a title.
				$container->appendChild($header = $doc->createElement('h2'));
				// Convert class name from upper CamelCase to Title Case.
				$header->appendChild($doc->createTextNode(preg_replace('/([^A-Z])([A-Z])/', "$1 $2", $object)));

				$container->appendChild($o_class->search($doc,$playout_search));
			}
		}
		break;

    /* Display an Item page */
    case 'item':
		if(!$access[$item]) {
			echo "No Access";
			break;
		}

		// TODO: Put these edit ones into a loop of some sort.
		if ($item=="Client" && $action=="edit") {
            if (method_exists($class,'headers')) {
                $objheaders = $class->headers($doc);
                if ($objheaders != null) {
                    if (is_array($objheaders)) {
                        $headers = array_merge($headers,$objheaders);
                    } else
                        $headers[] = $objheaders;
                }
            }
		}

		if ($item=="Install" && $action=="edit") {
            if (method_exists($class,'headers')) {
                $objheaders = $class->headers($doc);
                if ($objheaders != null) {
                    if (is_array($objheaders)) {
                        $headers = array_merge($headers,$objheaders);
                    } else
                        $headers[] = $objheaders;
                }
            }
		}

		$form = module::form_dom($doc);

		$iteminput = $doc->createElement('input');
		$iteminput->setAttribute('type','hidden');
		$iteminput->setAttribute('name','item');
		$iteminput->setAttribute('value',$item);
		$form->appendChild($iteminput);

		if ($action == 'edit') $form->appendChild($class->form($doc,$id));
		else if ($action == 'remove') $form->appendChild($class->form($doc,$id));
		else if ($action == 'view') $form->appendChild($class->view($doc,$id));
		else if ($action == 'import') $form->appendChild($class->import($doc));
		else if ($action == 'template') $form->appendChild($class->template($doc,$id));
		else $form->appendChild($class->overview($doc));
		$doc->appendChild($form);

		break;

    /* Display "Home" page */
    case 'home':
		$h1 = $doc->createElement('h1');
		$text = $doc->createTextNode('Playout Overview');
		$h1->appendChild($text);
        $doc->appendChild($h1);

		$p = $doc->createElement('p');
		$p->setAttribute('style','text-align: left; font-size: small');
		$text = $doc->createTextNode('The playout module allows Retromod to be interfaced with third-party playout clients.');
		$p->appendChild($text);
		$doc->appendChild($p);

		$br = $doc->createElement('br');
        $doc->appendChild($br);

		$p = $doc->createElement('p');
		$p->setAttribute('style','text-align: left; font-size: small');
		$p->setAttribute('size','smaller');
		$text = $doc->createTextNode('Each playout Client may have multiple installations. For instance, you may be running two radio studios, both using the Flywire playout client. This will allow media to be transferred to both studios.');
		$p->appendChild($text);
		$doc->appendChild($p);

}

//Convert headers to text.
//Stupid way to do it but the only way I could think of.
$headerstr = '<script language="javascript" src="'.WWWROOT.'stylesheet.php?moduleID='.$moduleID.'&file=SearchBox.js"></script>';
/* Add searchbox javascript */
$headerdoc = new DOMDocument();
$script1 = $doc->createElement('script');
$script1->setAttribute('language', 'javascript');
$script1->setAttribute('src', WWWROOT."stylesheet.php?moduleID=".$moduleID."&file=Traffic.js");
$script1->appendChild($doc->createTextNode(''));
foreach($headers as $header) {
    $headerdoc = new DOMDocument();
    $importedNode = $headerdoc->importNode($header,true);
    $headerdoc->appendChild($importedNode);
    $headerstr .= $headerdoc->saveHTML();
}

$page = new page('',$headerstr);
$page->header();
echo $doc->saveXML();
$page->footer();
?>
