# $Id$

# /** Extends the core storage class to contain parameters specific to this component. */
package playout::Storage;

# Specify parent for inheritance.
@ISA = (Retromod::Storage);

# /** Automatically loads core and component storage parameters. */
sub new {
	my $that = shift;
	my $class = ref($that) || $that;

	# Loads up core storage tables and fields.
	my $self = $class->SUPER::new();

	# Define names of the table(s) and fields storing data for this component.

	$self->{table_playout_client} = Retromod::Constant->TABLE_PREFIX."playout_client";
	$self->{playout_client_id} = "id";
	$self->{playout_client_name} = "name";
	$self->{playout_client_defaults} = "defaults";

	$self->{table_playout_install} = Retromod::Constant->TABLE_PREFIX."playout_install";
	$self->{playout_install_id} = "id";
	$self->{playout_install_client} = "client";
	$self->{playout_install_name} = "name";
	$self->{playout_install_params} = "params";

	bless ($self, $class);
	return $self;
}

1;